<!--
	Demo PHP class CaesarCipher
	Version: 1.1
	Author: Vladimir Kheifets (vladimir.kheifets@online.de)	
	Copyright ©2021 Vladimir Kheifets All Rights Reserved
-->

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Class CaesarCipher demo</title>
<link rel="stylesheet" href="CaesarCipher.css" >
<script src="CompactDOM.min.js"></script>
<script src="CaesarCipher.js"></script>
</head>
<?
$alphabet = isset($_POST['alphabet'])?$_POST['alphabet']:"latina";
$n_text = isset($_POST['n_text'])?$_POST['n_text']:1;
$key = isset($_POST['key'])?$_POST['key']:1;

include_once("tests/test_$alphabet.php");
include_once("alphabets/alphabet_$alphabet.php");

$options_key = "";
$max_keys = count($alphabet_frequency[$alphabet]);
for ($i=1; $i < $max_keys; $i++) { 
	$selected = $i==$key?"selected":"";
	$options_key .= "<option $selected>$i</option>";
}

$options_arr=[
"latina" => "Latina",
"ru" => "Русский",
"en" => "English",
"de" => "Deutsch"
];
$options = "";
foreach($options_arr as $value=> $text){
	$selected = $value==$alphabet?"selected":"";
	$options .= "<option value=\"$value\" $selected>$text</option>";
}
$sel_text = "";
foreach($test_text as $n => $text){
	$sel_text .= select_text($n, $n_text, $text);
}	
echo <<<HTML
<body>
<div align="center" style="display: inline-block;margin:0 auto">
<h1>Шифр Цезаря</h1>
<h2>Демо PHP класса CaesarCipher</h2>
<p>Выберите язык, ключ шифрования и текст, который требуется зашифровать</p>
<form name="test" method="post">
Язык: <select name="alphabet" id="alphabet">
$options
</select>
 Ключ: <select name="key" id="key"> 
$options_key
</select>
<input name="" type="submit" value ="Выполнить">
$sel_text
</form>
HTML;

include_once("ClassCaesarCipher.php");

//https://www.alto-booking.com/test/PHP_SU/CaesarCipherN.php?alphabet=de&test=5&key=9
$CaesarСipher = new CaesarCipher($alphabet_frequency[$alphabet]);

//-----------------------------------------
$text = $test_text[$n_text];
$text_encode = $CaesarСipher->encode($text, $key) -> text;
$text_decode = $CaesarСipher->decode($text_encode, $key) -> text;
print_text("Зашифрованный текст с использованием ключа: $key", $text_encode);
print_text("Расшифрованный текст с использованием известного ключа", $text_decode);

//---------------------------------------------------------------------------

echo "<br><hr><b>Взлом шифра с использование метода BruteForceDecoding</b><br>";
$res = $CaesarСipher->BruteForceDecoding($text_encode);
$MaxRatingKey = $res -> MaxRatingKey;			
$MaxRating = $res -> MaxRating;
$decoded = $res -> decoded;
$keyRating = $res -> keyRating;
$rating = $res -> rating;
print_text("Определён Kлюч: $MaxRatingKey для текта с максимальным рейтингом: $MaxRating", $decoded[$MaxRatingKey]);
block_view_trigger(1,"Результаты для всех возможных ключей шифрования");	
foreach ($rating as $item)
{
	$key=$item[0];
	$text=$decoded[$key];
	print_text("Рейтинг текста: {$keyRating[$key]} ключ: $key",$text);
}
echo "</div>";
//---------------------------------------------------------------------------

echo "<br><hr><b>Взом шифра с использование метода DecodingByCharacterFrequency</b><br>";
$res = $CaesarСipher->DecodingByCharacterFrequency($text_encode);

if($res->error == 2)
{
	echo "Взлом шифра этим методом невозможен. Используйте метод BruteForceDecoding";
}
else
{

	$character = $res->MostFrequentlyCharacter;
	$indA = $res->MostFrequentlyCharacterInd;	
	$character = ord($character)==32?"пробел":$character;	
	echo "<p>Часто используемый символ в зашифрованном тексте: '$character', порядковы номер в алфавите $indA</p>";    
    $keyRating = $res -> keyRating;
	$MaxRatingKey = $res -> MaxRatingKey;
	$MaxRating = $res -> MaxRating;
	$decodedKeys = $res -> decodedKeys;	
	$alldecoded = $res -> decoded;
	$rating = $res -> rating;
	$i_decoded = $decodedKeys[$MaxRatingKey];
	$decoded = $alldecoded[$i_decoded];	
	$label = "Определён Kлюч: $MaxRatingKey для текта с максимальным рейтингом: $MaxRating";
	print_text($label, $decoded[3]);
	block_view_trigger(2,"Результаты для всех возможных ключей шифрования");

	foreach ($rating as $item) 
	{	
		if($item[1]>0)
		{	
			$key=$item[0];
			$i=$decodedKeys[$key];
			$decoded = $alldecoded[$i];			
			$character = ord($decoded[0])==32?"пробел":$decoded[0];		
			$label = "Часто используемый символ алфавита: '$character'";
			$label .= ", порядковы номер  в алфавите {$decoded[1]}";
			
			$label .= ", ключ: $indA - {$decoded[1]} = $key<br>";
			$label .= "Рейтинг текста: {$keyRating[$key]}";			
			print_text($label, $decoded[3]);
		}

	}
}
?>
</div>
</div>
</body>
</html>
<?
//---------------------------------------------------------------------------
function print_text($label, $text){
echo <<<HTML
<p>
$label<br>
<textarea rows=5 cols=100>$text</textarea>
</p>
HTML;
}

function select_text($i, $i_check, $text){
$checked = $i==$i_check?"checked":"";	
return <<<HTML
<p>
<div><input name="n_text" id="n_text" type="radio" value="$i" $checked>$i</div>
<textarea rows=1 cols=100>$text</textarea>
</p>
HTML;
}

function block_view_trigger($i,$text){
echo <<<HTML
	<div id='vbl$i'>$text</div>
	<span id='sbl$i'>&#9660;</span>
	<div id='bl$i'>
	HTML;
}

?>